{ This is a descendant of a TListBox that allows for editing
of any of the ListBox Items
This component is freeware. Do with it what ever you want. but 
I will not be held liable for any damage it does (you have the source)

It has one new Method : DoEdit

Call this method when you want to edit a selected item.
}

unit SKEditList;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, DsgnIntf, stdctrls;

type
  TAbout = class(TPropertyEditor)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
    function GetValue: string; override;
  end;

  TSKEditList = class(TListBox)
  private
    FAbout: TAbout;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    Procedure Loaded; override;
    Procedure Click; override;
    Procedure DoEdit;
  published
    property About: TAbout read FAbout write FAbout;
  end;

  TListEdit = class(TCustomEdit)
   Private
   Public
    Procedure KeyPress(var Key: Char); override;
    Procedure EditDone;
   Published
  End;

procedure Register;


  Var

   FEditList : TSKEditList;
   FEditBox : TListEdit;
   OldIndex : Integer;

implementation

procedure TAbout.Edit;
begin
  Application.MessageBox('TSKEditList component v1.00 for Delphi. (C) 1998 Robert Jones. This component is freeware.',
                         'About TSKEditList Component', MB_OK + MB_ICONINFORMATION);
end;

function TAbout.GetAttributes: TPropertyAttributes;
begin
  Result:= [paMultiSelect, paDialog, paReadOnly];
end;

function TAbout.GetValue: string;
begin
  Result:= '(about)';
end;

Procedure TListEdit.EditDone;
Begin
    (Parent As TSKEditList).Items.Delete(OldIndex);
    (Parent As TSKEditList).Items.Insert(OldIndex, FEditBox.Text);
    FEditBox.Visible := False;
End;

procedure TListEdit.KeyPress(var Key: Char);
 Var
  OldWidth : Integer;
  TextWidth : Integer;
  NewWidth : Integer;
begin
 TextWidth := (Parent As TSKEditList).Canvas.TextWidth(FEditBox.Text);
 OldWidth := (Parent As TSKEditList).Canvas.TextWidth((Parent As TSKEditList).Items.Strings[OldIndex]);
  If OldWidth > TextWidth Then
   NewWidth := OldWidth
    Else
   NewWidth := TextWidth;

FEditBox.Width := NewWidth + (Parent As TSKEditList).Canvas.TextWidth('     ');
 If Key = #13 Then
  Begin
    EditDone;

   Key := #0;
   (Parent As TSKEditList).Invalidate;
  End;
end;

Procedure TSKEditList.Click;
Begin
  If FEditBox.Visible Then
   FEditBox.EditDone;
End;

Procedure TSKEditList.Loaded;
Begin
  FEditBox := TListEdit.Create(FEditList);
  FEditBox.Parent := Self;
  FEditBox.Visible := False;
  FEditBox.ParentFont := True;
End;

Procedure TSKEditList.DoEdit;
 Var
  ListRect : TRect;
Begin
  ListRect := ItemRect(ItemIndex);
  FEditBox.AutoSize := False;
  FEditBox.Top := ListRect.Top;
  FEditBox.Left := ListRect.Left;
  FEditBox.Width := Canvas.TextWidth(Items.Strings[ItemIndex]) + Canvas.TextWidth('     ');
  FEditBox.Height := Canvas.TextHeight(Items.Strings[ItemIndex]);
  FEditBox.Text := Items.Strings[ItemIndex];
  OldIndex := ItemIndex;
  If MultiSelect Then
   Selected[ItemIndex] := False
  Else
   ItemIndex := -1;
  FEditBox.Ctl3D := False;
  FEditBox.Visible := True;
  FEditBox.SelectAll;
  FEditBox.SetFocus;
End;

constructor TSKEditList.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
end;

Destructor TSKEditList.Destroy;
Begin
  FEditBox.Free;
 inherited Destroy;
End;

procedure Register;
begin
  RegisterComponents('Samples', [TSKEditList]);
  RegisterPropertyEditor(TypeInfo(TAbout), TSKEditList, 'ABOUT', TAbout);
end;

end.
